'+--------------------------------------------------------------------------+
'|                               zColorPick                                 |
'|                                                                          |
'|                              Color picker.                               |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2007                             |
'|                           www.zapsolution.com                            |
'|                         support@zapsolution.com                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 08-04-2007 (MM-DD-YYYY)            |
'|                        Last revised : 08-24-2007 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

%CB_ADDSTRING                                   = &H143
%CB_GETCURSEL                                   = &H147
%CB_GETLBTEXT                                   = &H148
%CB_GETLBTEXTLEN                                = &H149
%CB_FINDSTRING                                  = &H14C
%CB_SETCURSEL                                   = &H14E
%CB_GETITEMDATA                                 = &H150
%CB_SETITEMDATA                                 = &H151
%CB_GETDROPPEDSTATE                             = &H157

%CBN_SELCHANGE                                  = 1
%CBS_SIMPLE                                     = &H1&
%CBS_DROPDOWNLIST                               = &H3&
%CBS_OWNERDRAWFIXED                             = &H10&
%CBS_AUTOHSCROLL                                = &H40&
%CBS_SORT                                       = &H100&
%CBS_HASSTRINGS                                 = &H200&
%CBS_NOINTEGRALHEIGHT                           = &H400&
%CBS_DISABLENOSCROLL                            = &H800&

%WM_SETCURSOR                                   = &H20
%WM_DRAWITEM                                    = &H2B
%WM_MEASUREITEM                                 = &H2C
%WM_CTLCOLORLISTBOX                             = &H134
%GWL_USERDATA                                   = -21
%WM_ENABLE                                      = &HA
%WM_RBUTTONDOWN                                 = &H204
%WS_EX_CLIENTEDGE                               = &H00000200
%WS_EX_WINDOWEDGE                               = &H00000100
%WS_BORDER                                      = &H00800000
%WS_VSCROLL                                     = &H00200000

%ODT_COMBOBOX                                   = 3
%ODA_DRAWENTIRE                                 = &H1
%ODA_SELECT                                     = &H2
%ODA_FOCUS                                      = &H4
%ODS_SELECTED                                   = &H0001
%ODS_DISABLED                                   = &H0004
%ODS_FOCUS                                      = &H0010
%GWL_STYLE                                      = -16

%IMAGE_BITMAP                                   = 0
%IMAGE_CURSOR                                   = 2
%LR_LOADFROMFILE                                = &H00000010

TYPE ColorRGB
    R AS BYTE
    G AS BYTE
    B AS BYTE
END TYPE

TYPE LOGPEN
  lopnStyle AS DWORD
  lopnWidth AS POINTAPI
  lopnColor AS DWORD
END TYPE

TYPE MEASUREITEMSTRUCT
  CtlType AS DWORD
  CtlID AS DWORD
  itemID AS DWORD
  itemWidth AS DWORD
  itemHeight AS DWORD
  itemData AS DWORD
END TYPE

TYPE DRAWITEMSTRUCT
  CtlType AS DWORD
  CtlID AS DWORD
  itemID AS DWORD
  itemAction AS DWORD
  itemState AS DWORD
  hwndItem AS LONG
  hDC AS DWORD
  rcItem AS RECT
  itemData AS DWORD
END TYPE

DECLARE FUNCTION CreatePenIndirect LIB "GDI32.DLL" ALIAS "CreatePenIndirect" (lpLogPen AS LOGPEN) AS DWORD
DECLARE FUNCTION GetPixel LIB "GDI32.DLL" ALIAS "GetPixel" (BYVAL hdc AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG) AS DWORD
DECLARE FUNCTION LoadImage LIB "USER32.DLL" ALIAS "LoadImageA" (BYVAL hInst AS DWORD, lpsz AS ASCIIZ, BYVAL uType AS DWORD, BYVAL cxDesired AS LONG, BYVAL cyDesired AS LONG, BYVAL fuLoad AS DWORD) AS DWORD
DECLARE FUNCTION MoveToEx LIB "GDI32.DLL" ALIAS "MoveToEx" (BYVAL hdc AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION LineTo LIB "GDI32.DLL" ALIAS "LineTo" (BYVAL hdc AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG) AS LONG
DECLARE FUNCTION DrawFocusRect LIB "USER32.DLL" ALIAS "DrawFocusRect" (BYVAL hDC AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION SetBkColor LIB "GDI32.DLL" ALIAS "SetBkColor" (BYVAL hdc AS DWORD, BYVAL crColor AS DWORD) AS DWORD
DECLARE FUNCTION SetTextColor LIB "GDI32.DLL" ALIAS "SetTextColor" (BYVAL hdc AS DWORD, BYVAL crColor AS DWORD) AS DWORD
DECLARE FUNCTION TextOut LIB "GDI32.DLL" ALIAS "TextOutA" (BYVAL hdc AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, lpString AS ASCIIZ, BYVAL nCount AS LONG) AS LONG
DECLARE FUNCTION GetClassName LIB "USER32.DLL" ALIAS "GetClassNameA" (BYVAL hwnd AS DWORD, lpClassName AS ASCIIZ, BYVAL nMaxCount AS LONG) AS LONG
DECLARE FUNCTION SetWindowText LIB "USER32.DLL" ALIAS "SetWindowTextA" (BYVAL hWnd AS DWORD, lpString AS ASCIIZ) AS LONG
DECLARE FUNCTION SetCursor LIB "USER32.DLL" ALIAS "SetCursor" (BYVAL hCursor AS DWORD) AS DWORD
DECLARE FUNCTION WindowFromDC LIB "USER32.DLL" ALIAS "WindowFromDC" (BYVAL hDC AS DWORD) AS LONG
DECLARE FUNCTION DestroyCursor LIB "USER32.DLL" ALIAS "DestroyCursor" (BYVAL hCursor AS DWORD) AS LONG

FUNCTION zGetColorPick(BYVAL hWnd AS LONG) AS LONG
    FUNCTION = zGetProperty(hWnd, %COLORPICK_COLOR)
END FUNCTION

SUB zLineI(BYVAL graphics AS LONG, BYVAL x1 AS LONG, BYVAL y1 AS LONG, BYVAL x2 AS LONG, BYVAL y2 AS LONG, BYVAL nSize AS LONG, BYVAL ARGBcolor AS LONG)
    LOCAL UsePen AS LONG
    CALL GdipCreatePen1(ARGBcolor, nSize, %UnitPixel, UsePen)
    CALL GdipDrawLineI(graphics, UsePen, x1, y1, x2, y2)
    CALL GdipDeletePen(UsePen)
END SUB

SUB zLine(BYVAL hDC AS LONG, BYVAL x1 AS LONG, BYVAL y1 AS LONG, BYVAL x2 AS LONG, BYVAL y2 AS LONG, BYVAL Style AS LONG, BYVAL nSize AS LONG, BYVAL nColor AS LONG)
    LOCAL hPen AS LONG, lp AS LOGPEN, p AS POINTAPI

    p.X = nSize: p.Y = nSize
    IF nSize > 1 THEN Style = 0 ' %PS_SOLID
    lp.lopnStyle = Style
    lp.lopnWidth = p
    lp.lopnColor = nColor
    hPen = SelectObject(hDC, CreatePenIndirect(lp))

    CALL MoveToEx(hDC, x1, y1&, BYVAL %NULL)
    CALL LineTo(hDC, x2, y2)

    CALL zDeleteObject(SelectObject(hDC, hPen))

END SUB

SUB zDrawRect3D(BYVAL hDC AS LONG, BYVAL x1 AS LONG, BYVAL y1 AS LONG, BYVAL x2 AS LONG, BYVAL y2 AS LONG, BYVAL PenTop AS LONG, BYVAL PenBottom AS LONG)
    x2 = x1 + x2 - 1
    y2 = y1 + y2 - 1
    CALL zLine(hDC, x1, y2, x1, y1, 0, 1, PenTop)
    CALL zLine(hDC, x1, y1, x2 + 1, y1, 0, 1, PenTop)
    CALL zLine(hDC, x2, y1, x2, y2, 0, 1, PenBottom)
    CALL zLine(hDC, x1, y2, x2 + 1, y2, 0, 1, PenBottom)
END SUB

FUNCTION zSTRL (BYVAL nValue AS LONG) AS STRING
    FUNCTION = LTRIM$(STR$(nValue))
END FUNCTION

FUNCTION zGetColorCombo(BYVAL hCombo AS LONG, BYVAL nItem AS LONG) AS LONG
    FUNCTION = SendMessage(hCombo, %CB_GETITEMDATA, nItem, 0)
END FUNCTION

FUNCTION zWindow(BYVAL StyleEx AS LONG, zTitle AS ASCIIZ, BYVAL Style AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL xW AS LONG, BYVAL yW AS LONG, BYVAL hParent AS LONG, BYVAL WinCodeptr AS LONG, BYVAL ID AS LONG) AS LONG
    LOCAL zClass AS ASCIIZ * 62, wc AS WndClassEx
    zClass = "ZCANY"
    IF Style = 0 THEN Style = %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPCHILDREN
    wc.cbSize = SIZEOF(wc)
    IsInitialized& = GetClassInfoEx(zInstance(), zClass, wc)
    IF IsInitialized&   = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS OR %CS_PARENTDC
       wc.lpfnWndProc   = WinCodeptr&
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = %EXTEND_EXTRA * 4
       wc.hInstance     = zInstance()
       wc.hIcon         = %NULL
       wc.hCursor       = %NULL
       wc.hbrBackground = hBrush&
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = %NULL
       IF RegisterClassEx(wc) THEN IsInitialized& = %TRUE
    END IF
    IF IsInitialized& THEN
       FUNCTION = CreateWindowEx(StyleEx, _
                                 zClass, _      ' window class name
                                 zTitle, _      ' window title
                                 Style, _       ' window style
                                 x, _           ' initial x position
                                 y, _           ' initial y position
                                 xW, _          ' initial x size
                                 yW, _          ' initial y size
                                 hParent, _     ' parent window handle
                                 ID, _          ' window menu handle
                                 zInstance(), _ ' program instance handle
                                 BYVAL %NULL)   ' creation parameters
    END IF
END FUNCTION

FUNCTION DetectCombo(BYVAL hCombo AS LONG, BYVAL lParam AS LONG) AS LONG
    LOCAL rc, rc1, rc2 AS RECT
    LOCAL hWnd AS LONG
    LOCAL zClass AS ASCIIZ * 32
    Ret& = %TRUE
    IF GetClassName(hCombo, zClass, SIZEOF(zClass)) THEN
       IF UCASE$(zClass) = "COMBOBOX" AND _
          SendMessage(hCombo, %CB_GETDROPPEDSTATE, 0, 0) THEN
          IF (GetWindowLong(hCombo, %GWL_STYLE) AND %CBS_OWNERDRAWFIXED) = %CBS_OWNERDRAWFIXED THEN
             CALL GetWindowRect(lParam, rc1)                ' Get list's RECT on screen
             CALL GetWindowRect(hCombo, rc2)                ' Get combo's RECT on screen
             IF rc1.nLeft = rc2.nLeft THEN                  ' compare left positions to avoid multiple actions
                hWnd = GetWindowLong(hCombo, %GWL_USERDATA)
                CALL GetWindowRect(hWnd, rc)                ' Get hWnd RECT on screen
                w& = rc2.nLeft - rc.nLeft
                rc1.nLeft   = rc2.nLeft - w&                ' calculate new left pos
                rc1.nRight  = rc2.nRight - rc2.nLeft + w&   ' calculate new width
                CALL SetWindowPos(lParam, 0, rc1.nLeft, rc1.nTop, _       ' set LB's new pos and width
                                  rc1.nRight + 24, rc1.nBottom - rc1.nTop, %SWP_NOZORDER)
             END IF
             Ret& = %FALSE
          END IF
       END IF
    END IF
    FUNCTION = Ret&
END FUNCTION

SUB ColorLongToRGB(A AS LONG, RetC AS ColorRGB)
    RetC.R = (A AND &HFF&)
    RetC.G = (A AND &HFF00&) / &H100&
    RetC.B = (A AND &HFF0000) / &H10000
END SUB

FUNCTION ColorProc (BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
    LOCAL rc          AS RECT
    LOCAL p           AS POINTAPI
    LOCAL zClass      AS ASCIIZ * 32
    LOCAL lpdis       AS DRAWITEMSTRUCT
    LOCAL lpmis       AS MEASUREITEMSTRUCT

    LOCAL imgW, imgH, graphics, hPen, hBrush, ImgAttr AS LONG
    LOCAL ps AS PAINTSTRUCT

    STATIC Img, hPickCursor AS LONG

    SELECT CASE LONG Msg

    CASE %WM_MEASUREITEM
         idCtl& = wParam                           ' control identifier
         LSET lpmis = PEEK$(lParam, SIZEOF(lpmis)) ' item-size information'
         IF lpmis.CtlType = %ODT_COMBOBOX THEN
            lpmis.itemHeight = 16
            POKE$ lparam, lpmis
            FUNCTION = 1: EXIT FUNCTION
         END IF

    CASE %WM_DRAWITEM
         LSET lpdis = PEEK$(lParam&, SIZEOF(lpdis)) ' for convenience
         IF lpdis.CtlType = %ODT_COMBOBOX THEN ' 3 Owner-drawn combo box
            IF lpdis.itemID < 0 THEN
               IF (lpdis.itemState AND %ODS_FOCUS) THEN
                  CALL DrawFocusRect(lpdis.hDC, lpdis.rcItem)
               END IF
            ELSE
             ' Fill item rectangle
               rc.nLeft   = lpdis.rcItem.nLeft
               rc.nTop    = lpdis.rcItem.nTop
               rc.nRight  = lpdis.rcItem.nRight - lpdis.rcItem.nLeft
               rc.nBottom = lpdis.rcItem.nBottom - lpdis.rcItem.nTop

               CALL zFillRect(lpdis.hDC, rc.nLeft, rc.nTop, rc.nRight, rc.nBottom, &HFFFFFF)
               CALL zFillRect(lpdis.hDC, rc.nLeft + 2, rc.nTop + 2, 13, rc.nBottom - 4, zGetColorCombo(lpdis.hwndItem, lpdis.itemID))
               CALL zDrawRect3D(lpdis.hDC, rc.nLeft + 2, rc.nTop + 2, 13, rc.nBottom - 4, 0, 0)

             ' TextOut uses current background and text colors
               Length& = SendMessage(lpdis.hwndItem, %CB_GETLBTEXTLEN, lpdis.itemID, 0)
               Item$ = SPACE$(Length&)
               CALL SendMessage(lpdis.hwndItem, %CB_GETLBTEXT, lpdis.itemID, BYVAL STRPTR(Item$))
             ' Set current background and text colors
               CALL SetBkColor(lpdis.hDC, &hFFFFFF)
               CALL SetTextColor(lpdis.hDC, &H0)
               CALL TextOut(lpdis.hDC, lpdis.rcItem.nLeft + 18, lpdis.rcItem.nTop + 2, _
                           (Item$), LEN(Item$))
             ' If enabled item has the input focus, call DrawFocusRect to set
             ' or clear the focus rectangle
               IF (lpdis.itemState AND %ODS_FOCUS) THEN
                  CALL DrawFocusRect(lpdis.hDC, lpdis.rcItem)
               END IF
            END IF
            FUNCTION = 1: EXIT FUNCTION
         END IF

    CASE %WM_CTLCOLORLISTBOX
         CALL EnumChildWindows(hWnd&, CODEPTR(DetectCombo), lParam)

    CASE %WM_COMMAND
         CALL GetClassName(lParam, zClass, SIZEOF(zClass))
         IF UCASE$(zClass) = "COMBOBOX" THEN
            IF HIWRD(wParam) = %CBN_SELCHANGE THEN
               Item& = SendMessage(lParam, %CB_GETCURSEL, 0, 0)
               IF Item& > -1 THEN
                  hCtl0& = GetWindowLong(lParam, %GWL_USERDATA)
                  T$ = zGetCTLText(hCtl0&)
                  RGBColor& = zGetColorCombo(lParam, Item&)
                  CALL zSetProperty(hWnd, %COLORPICK_COLOR, zColorARGB(255, RGBcolor&))
                  CALL zUpdateWindow(hWnd, 0)
                  CALL PostMessage(GetForegroundWindow, %WM_COMMAND, MAKLNG(GetDlgCtrlID(hWnd), 0), zGetColorPick(hWnd))
               END IF
            END IF
         ELSE
            hCombo& = zGetProperty(hWnd, %COLORPICK_COMBO)
            'CALL EnableWindow(hCombo&, %TRUE)
            'CALL SendMessage(hCombo&, &H14F, TRUE%, 0) '//  %CB_SHOWDROPDOWN
            'msgbox str$(hCombo&)
            CALL zPutFocusOn(hCombo&)
            'beep
         END IF
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_ENABLE
         T$ = zGetCTLText(hWnd)
         IF ASC(T$) = 47 THEN ' Enable/Disable child color combo
            CALL EnableWindow(zGetProperty(hWnd, %COLORPICK_COMBO), wParam)
         END IF

    CASE %WM_LBUTTONUP
'         T$ = zGetCTLText(hWnd)
         T$ = zGetCTLText(hWnd)
         IF ASC(T$) = 47 THEN
            p.X = LOWRD(lParam): p.Y = HIWRD(lParam)
            CALL GetClientRect(hWnd, rc)
            IF p.X > rc.nBottom AND p.X < rc.nRight - 17 THEN
               CALL PostMessage(GetForegroundWindow, %WM_COMMAND, MAKLNG(GetDlgCtrlID(hWnd), 0), zGetColorPick(hWnd))
            END IF
         END IF
         
    CASE %WM_MOUSEMOVE, %WM_LBUTTONDOWN, %WM_RBUTTONDOWN
         T$ = zGetCTLText(hWnd)
         IF ASC(T$) = 47 THEN
            p.X = LOWRD(lParam): p.Y = HIWRD(lParam)
            CALL GetClientRect(hWnd, rc)
            IF p.X > rc.nBottom AND p.X < rc.nRight - 17 THEN
               IF hPickCursor& = 0 THEN
                  hPickCursor& = LOADIMAGE(0, (SK_FOLDER() + "pipette.cur"), %IMAGE_CURSOR, 0, 0, %LR_LOADFROMFILE)
               END IF
               CALL SetCursor(hPickCursor&)
               IF (wParam AND %MK_LBUTTON) = %MK_LBUTTON THEN
                   hDC& = GetDC(hWnd)
                   RGBColor& = GetPixel(hDC&, p.X, p.Y)
                   R? = zGetRValue(RGBColor&)
                   G? = zGetGValue(RGBColor&)
                   B? = zGetBValue(RGBColor&)
                   CALL ReleaseDC(hWnd&, hDC&)
                   CALL zSetProperty(hWnd, %COLORPICK_COLOR, zColorARGB(255, RGBcolor&))
                   hCombo& = zGetProperty(hWnd, %COLORPICK_COMBO)
                   IF GetFocus <> hCombo& THEN CALL SetFocus(hCombo&)
                   CALL zUpdateWindow(hWnd, 0)
               END IF
            ELSE
               CALL SetCursor(LoadCursor(%NULL, BYVAL %IDC_ARROW))
            END IF
         END IF

    CASE %WM_ERASEBKGND
         FUNCTION = 1: EXIT FUNCTION

    CASE %WM_PAINT, %WM_PRINT
         IF Msg = %WM_PAINT THEN
           hDCpaint& = BeginPaint(hWnd, ps)
         ELSE
           hDCpaint& = wParam
         END IF
   'CASE %WM_ERASEBKGND, %WM_PRINT
   '     hDCpaint& = wParam
         T$ = zGetCTLText(hWnd)
         IF IsWindowEnabled(hWnd) THEN
            IF Img = 0 THEN
               Img = zAddResource((SK_FOLDER() + "color190.bmp"))
            END IF
            IF ASC(T$) = 47 THEN ' "/"
               CALL GetClientRect(hWnd, rc)
'hDC& = hDCpaint&
hDC& = zDoubleBuffer(hDCpaint&, rc.nRight, rc.nBottom, 1)
            
               CALL zPaintBrushBitmap(hDC&, 0, 0, rc.nRight - 24, rc.nBottom, zColorARGB(255, 0))
               CALL zPaintBrushBitmap(hDC&, 1, 1, rc.nBottom - 2, rc.nBottom - 2, zGetColorPick(hWnd))
               IF GdipCreateFromHDC(hDC&, graphics) = 0 THEN

                  CALL zGetImageSize(Img, imgW, imgH)
                  CALL GdipDrawImageRectRectI(graphics, Img, rc.nBottom, 1, rc.nRight - rc.nBottom - 24, rc.nBottom - 8, _
                                              0, 0, ImgW, ImgH, %UnitPixel, ImgAttr)
                  LOCAL p1, p2 AS POINTAPI
'
                  p1.x = rc.nBottom - 1: p1.y = 0
                  p2.x = rc.nBottom + (rc.nRight - rc.nBottom - 24) \ 2 : p2.y = 4
                  CALL GdipCreateLineBrushI(p1, p2, zColorARGB(255, &H0), zGetColorPick(hWnd&), %WrapModeTile, hBrush)
                  CALL GdipCreatePen2(hBrush, 5, %UnitPixel, hPen)
                  CALL GdipDrawLineI(graphics, hPen, p1.x + 1, rc.nBottom - 4, p2.x, rc.nBottom - 4)
                  CALL GdipDeletePen(hPen)
                  CALL GdipDeleteBrush(hBrush)

                  p1.x = p2.x - 1: p2.x = rc.nRight - 24
                  CALL GdipCreateLineBrushI(p1, p2, zGetColorPick(hWnd), zColorARGB(255, &HFFFFFF), %WrapModeTile, hBrush)
                  CALL GdipCreatePen2(hBrush, 5, %UnitPixel, hPen)
                  CALL GdipDrawLineI(graphics, hPen, p1.x + 1, rc.nBottom - 4, p2.x, rc.nBottom - 4)
                  CALL GdipDeletePen(hPen)
                  CALL GdipDeleteBrush(hBrush)

                  CALL GdipDeleteGraphics(graphics)
CALL zDoubleBuffer(0, 0, 0, 0)
               END IF
            END IF
            IF Msg = %WM_PAINT THEN
               CALL EndPaint(hWnd, ps)
            END IF
            FUNCTION = 0: EXIT FUNCTION
         END IF
'        FUNCTION = 1: EXIT FUNCTION

    CASE %WM_DESTROY
         CALL zDeleteResource(Img)
         CALL DestroyCursor(hPickCursor&)
    END SELECT

    FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
END FUNCTION

FUNCTION zRGBtoHEX(BYVAL ColrRGB???) AS STRING
    FUNCTION = ",&H" + RIGHT$("00" + HEX$(zGetRValue(ColrRGB???)), 2) + _
                       RIGHT$("00" + HEX$(zGetGValue(ColrRGB???)), 2) + _
                       RIGHT$("00" + HEX$(zGetBValue(ColrRGB???)), 2)
END FUNCTION

FUNCTION zColorPick(BYVAL Label$, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL xW AS LONG, BYVAL yH AS LONG, BYVAL hParent AS LONG, BYVAL ID AS LONG, BYVAL UseColor$) AS LONG
    LOCAL hCtrl, hCombo, Style, K, Item, SetItem AS LONG
    yH = MAX&(yH, 24)
    hCtrl = zWindow(0, "/", %WS_CHILD OR %WS_VISIBLE, x, y, xW, yH, hParent, CODEPTR(ColorProc), ID)
    IF hCtrl THEN
       Style = %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %CBS_DROPDOWNLIST OR %CBS_HASSTRINGS OR %CBS_DISABLENOSCROLL OR _
               %CBS_OWNERDRAWFIXED OR %WS_VSCROLL OR %CBS_NOINTEGRALHEIGHT
'       hCombo = CreateWindowEx(0, "COMBOBOX", (Label$), _
 '                              Style, xW - 16 , 1, 16, 152, hCtrl, ID, zInstance(), BYVAL %NULL)
       hCombo = CreateWindowEx(0, "COMBOBOX", (Label$), _
                               Style, xW - 24 , 1, 0, 152, hCtrl, ID, zInstance(), BYVAL %NULL)
       CALL zSetCTLFont(hCombo, zDefaultFont)

       IF LEN(Label$) THEN
          Item = 0: SetItem = -1
          FOR K = 1 TO PARSECOUNT(Label$) STEP 2
              Af$ = PARSE$(Label$, K)
              CALL SendMessage(hCombo, %CB_ADDSTRING, 0, BYVAL STRPTR(Af$))
              Af$ = PARSE$(Label$, K + 1)
              R? = VAL("&H" + MID$(Af$, 3, 2))
              G? = VAL("&H" + MID$(Af$, 5, 2))
              B? = VAL("&H" + MID$(Af$, 7, 2))
              CALL SendMessage(hCombo, %CB_SETITEMDATA, Item, RGB(R?,G?,B?))
              IF R? = R1? AND G? = G1? AND B? = B1? THEN SetItem = Item
              INCR Item
          NEXT
          IF SetItem > -1 THEN CALL SendMessage(hCombo, %CB_SETCURSEL, SetItem, 0)
       END IF

       Af$ = PARSE$(UseColor$, 2)
       IF LEN(Af$) THEN
          R? = VAL("&H" + MID$(Af$, 3, 2))
          G? = VAL("&H" + MID$(Af$, 5, 2))
          B? = VAL("&H" + MID$(Af$, 7, 2))
       ELSE
          R? = 255: G? = 255: B? = 255
       END IF
       CALL zSetProperty(hCtrl, %COLORPICK_COLOR, zColorARGB(255, RGB(R?, G?, B?)))
       CALL zSetProperty(hCtrl, %COLORPICK_COMBO, hCombo) ' Store child combo handle
       CALL SetWindowLong(hCombo, %GWL_USERDATA, hCtrl)

       CALL zPushButton(hCtrl, (SK_FOLDER() + "BTN_DropDown.png"), "", xW - 24, 0, 24, yH, 0, SK_BTNTEXTCOLOR(), 0, 0)

    END IF
    FUNCTION = hCtrl

END FUNCTION
