'+--------------------------------------------------------------------------+
'|                                zSkin12                                   |
'|                                                                          |
'|                      Skin Engine for VISTA and XP                        |
'|           with full crystal and blur effect in composited mode           |
'|                                                                          |
'|                Example of what is going on behind the hood.              |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2007                             |
'|                           www.zapsolution.com                            |
'|                         support@zapsolution.com                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 08-04-2007 (MM-DD-YYYY)            |
'|                        Last revised : 08-27-2007 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE EXE "zSkin12.exe"

DECLARE SUB skDebug LIB "SKENGINE.DLL" (BYVAL Msg$)

#RESOURCE "control.pbr"

'// Return the SKIN Author's name
DECLARE FUNCTION SK_AUTHOR() AS STRING
'// Return SKIN color set
DECLARE FUNCTION SK_ACTIVECAPTION() AS LONG       '// COLOR ACTIVE CAPTION
DECLARE FUNCTION SK_INACTIVECAPTION() AS LONG     '// COLOR INACTIVE CAPTION
DECLARE FUNCTION SK_TEXTCOLOR() AS LONG           '// COLOR TEXT
DECLARE FUNCTION SK_BTNTEXTCOLOR() AS LONG        '// COLOR BUTTON TEXT
DECLARE FUNCTION SK_POPMENUTEXT() AS LONG         '// COLOR POPUP MENU TEXT
DECLARE FUNCTION SK_POPMENUHILITE() AS LONG       '// COLOR POPUP MENU HILIGHTED TEXT
DECLARE FUNCTION SK_ACTIVEMENUBAR() AS LONG       '// COLOR MENU BAR HILIGHTED ITEM
DECLARE FUNCTION SK_INACTIVEMENUBAR() AS LONG     '// COLOR MENU BAR DEFAULT COLOR
DECLARE FUNCTION SK_CAPTIONFONT() AS STRING       '// CAPTION FONT TO USE
DECLARE FUNCTION SK_CAPTIONFONTHEIGHT() AS LONG   '// CAPTION FONT SIZE
DECLARE FUNCTION SK_PUSHBUTFONTSIZE() AS LONG     '// PUSH BUTTON FONT SIZE
DECLARE FUNCTION SK_TRACKHICOLOR() AS LONG        '// TRACK BAR HIGHLIGHTED VALUE
DECLARE FUNCTION SK_TEXTFONT() AS STRING          '// TEXT FONT TO USE
DECLARE FUNCTION SK_AEROEMULATE() AS LONG         '// CHECK IF AERO EMULATION IS ON
DECLARE FUNCTION SK_AEROBLURLEVEL() AS LONG       '// AERO BLURING LEVEL
DECLARE FUNCTION SK_AEROCOLOR() AS LONG           '// AERO GLASS COLOR
DECLARE FUNCTION SK_AEROTIMERDELAY() AS LONG      '// AERO TIMER REFRESH DELAY
DECLARE FUNCTION SK_COLORLABEL() AS STRING        '// GDIPLUS COLOR LIST FOR COLORPICKER COMBO

#INCLUDE "ZSKIN.INC"
#INCLUDE "ZCOLORPICK.INC"
'------------------------------------------------------------------------------------------
' LOCAL section
'------------------------------------------------------------------------------------------

%XMIN_SIZE = 600
%YMIN_SIZE = 400

%ID_PUSHBUTTON       = 1
%ID_SCRIPTBUTTON     = 2
%ID_PLAYBUTTON       = 3
%ID_LEFTBUTTON       = 4
%ID_RIGHTBUTTON      = 5
%ID_FRAMEBUTTON      = 6
%ID_CRYSTALBUTTON    = 7
%ID_AEROBUTTON       = 8
%ID_TRACK_OPACITY    = 9
%ID_TRACK_BLURLEVEL  = 10
%ID_AEROCRYSTAL      = 11
%ID_AEROBLUR         = 12
%ID_AERODISABLE      = 13
%ID_COLORPICK        = 14
%ID_LABEL            = 15

%AERO_TIMER          = 1

'// Main entry point
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL wc          AS WndClassEx
    LOCAL zClass      AS ASCIIZ * 80
    LOCAL dwExStyle   AS DWORD
    LOCAL dwStyle     AS DWORD
    LOCAL rc          AS RECT
    LOCAL x           AS LONG
    LOCAL y           AS LONG
    LOCAL hMutex      AS DWORD
    LOCAL hFound      AS DWORD
    LOCAL hMain       AS LONG
'
    LOCAL hWinXP_Lib           AS LONG ' Handle to WinXP Theme DLL
    LOCAL hWinXP_IsThemeActive AS LONG ' Handle to WinXP's IsThemeActive function
    LOCAL IsInitialized        AS LONG
    LOCAL hGDIplus             AS LONG ' GDIPLUS

    zClass = "ZSKINPOPUP"
'
    hMutex = CreateMutex(BYVAL %Null, 0, zClass)
    IF hMutex THEN
       IF GetLastError = %ERROR_ALREADY_EXISTS THEN
          DO
             hFound = FindWindow(zClass, ""): IF hFound THEN EXIT DO
             WHILE PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE): WEND
          LOOP
          IF IsIconic(hFound) THEN CALL ShowWindow(hFound, %SW_RESTORE)
          CALL SetForeGroundWindow(hFound)
          FUNCTION = 0
          EXIT FUNCTION
       END IF
    END IF

    CALL zSplitN(zExeName(), "", MyTitle$)
    MyTitle$ = PARSE$(MyTitle$, ".", 1)
'   // Check first for a valid OS version (at least XP)
    IF zOsVersion < 501 THEN
       MsgBox zSysErrorMessage(197),,MyTitle$
       EXIT FUNCTION
    END IF

    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(zInstance, zClass, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS ' OR %CS_DROPSHADOW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = %EXTEND_EXTRA * 4
       wc.hInstance     = zInstance
       wc.hIcon         = %NULL ' LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = %NULL
       wc.hbrBackground = %NULL ' Don't paint the class window background
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF
'
    IF IsInitialized THEN
'
     ' Load the WinXP Theme support (if applicable)
       hWinXP_Lib = LoadLibrary("UxTheme.dll")
       IF hWinXP_Lib THEN
          hWinXP_IsThemeActive = GetProcAddress(hWinXP_Lib, "IsThemeActive")
       END IF
'
'CALL zDwmEnableComposition(0)

       CALL InitCommonControls
'
'      // Init GDIPLUS
       hGDIplus = zGdipStart()
'
     ' Window Extended Style
'      // %WS_EX_COMPOSITED is a prerequisite (available only on XP and above)
       dwExStyle = %WS_EX_LAYERED
       IF zOsVersion > 500 THEN dwExStyle = dwExStyle OR %WS_EX_COMPOSITED '// XP and above

'IF zOsVersion > 599 THEN dwExStyle = 0

     ' Windows Style, avoid using %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN with the Skin Engine
       dwStyle = %WS_POPUP ' OR %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN
'
       CALL SetRect(rc, 0, 0, %XMIN_SIZE, %YMIN_SIZE)
'      // Note: indeed we don't need AdjustWindowRectEx, because we use do not use a non-client area
'      // but it won't hurt anything to keep it, in case we change our mind ;)
       CALL AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)  ' Adjust Window To True Requested Size
'
       x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - rc.nRight - rc.nLeft) \ 2, 0)
       y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - rc.nBottom - rc.nTop) \ 2, 0)
'
     ' Create The Window
       MyTitle$ = "Template"
       hMain = CreateWindowEx(dwExStyle, _           ' Extended Style For The Window
                             zClass, _               ' Class Name
                             (MyTitle$), _           ' Window Title
                             dwStyle, _              ' Defined Window Style
                             x, y, _                 ' Window Position
                             rc.nRight - rc.nLeft, _ ' Calculate Window Width
                             rc.nBottom - rc.nTop, _ ' Calculate Window Height
                             %NULL, _                ' No Parent Window
                             %NULL, _                ' No Menu
                             wc.hInstance, _         ' Instance
                             BYVAL %NULL)            ' Dont Pass Anything To WM_CREATE
'
       IF hMain THEN

        ' Apply WinXP Theme support
          LOCAL lRes AS LONG, pProc AS DWORD
          IF hWinXP_IsThemeActive THEN
             CALL DWORD hWinXP_IsThemeActive USING IsThemeActive TO lRes
             IF lRes  THEN pProc = GetProcAddress(lRes, "EnableThemeDialogTexture")
             IF pProc THEN CALL DWORD pProc USING EnableDialogTheme(hMain, &H01 OR &H02 OR &H04 OR &H06)
          END IF

'         // Load SKIN components and create SYS buttons
          CALL zInitSkin(hMain, "Moonraker.zsk")

'         // Add the child controls being used by the application
          CALL AddChildControls(hMain)

'         // *************************************************
'         // Show main window
'         // Create region and paint controls to double buffer
'         // *************************************************
          CALL zShowMainWindow(5) ' 5 = UseStep for layered animation

          IF SK_AEROEMULATE() THEN CALL SetTimer(hMain, %AERO_TIMER, SK_AEROTIMERDELAY(), %NULL)
          WHILE GetMessage(Msg, %NULL, 0, 0)  ' SK_MILLISECOND
             IF IsDialogMessage(hMain, Msg) = %FALSE THEN
                CALL TranslateMessage(Msg)
                CALL DispatchMessage(Msg)
             END IF
          WEND
          IF SK_AEROEMULATE() THEN CALL KillTimer(hMain, %AERO_TIMER)

          FUNCTION = msg.wParam
       END IF

'      // UNLOAD the WinXP Theme DLL (if necessary)
       IF hWinXP_Lib THEN CALL FreeLibrary(hWinXP_Lib)

'      // UNLOAD GDIPLUS
       CALL zGdipEnd(hGDIplus)

    END IF
'
    IF hMutex THEN CALL CloseHandle(hMutex)
'
END FUNCTION

'// Add child controls to main window
SUB AddChildControls(BYVAL hMain AS LONG)

    LOCAL hBut, imgW, imgH AS LONG
    LOCAL Alpha, Red, Green, Blue AS BYTE

    hBut = zFrameButton(hMain, (SK_FOLDER() + "Aero.png"), "", 13, 66, %XMIN_SIZE - 26, %YMIN_SIZE - 80, %ID_AEROBUTTON, 0)
    CALL zSetAnchorMode(hBut, %ANCHOR_HEIGHT_WIDTH)
    CALL zSetZorder(hBut, %HWND_BOTTOM)

    hBut = zPushButton(hMain, (SK_FOLDER() + "BTN_Halo.png"), "Halo button", (%XMIN_SIZE - 100) \ 2, (%YMIN_SIZE - 32) \ 2, 100, 32, %ID_PUSHBUTTON, SK_BTNTEXTCOLOR(), 0, 0)
    'CALL EnableWindow(hBut, %FALSE)
    CALL zSetAnchorMode(hBut, %ANCHOR_CENTER)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "This is a halo button")

    hBut = zPushButton(hMain, (SK_FOLDER() + "BTN_Push.png"), "Crystal button", (%XMIN_SIZE - 120) \ 2, 99, 120, 40, %ID_CRYSTALBUTTON, SK_BTNTEXTCOLOR(), -1, 0)
    CALL zSetAnchorMode(hBut, %ANCHOR_CENTER)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "This is a text push button")

    hBut = zButImage(hMain, (SK_FOLDER() + "BTN_Script_load.png"), -100, -100, %ID_SCRIPTBUTTON, 0)
    CALL zGetImageSize(zGetButImageProperty(hBut), imgW, imgH): imgW = imgW \ 5
    CALL MoveWindow(hBut, 100, 100, imgW, imgH, %TRUE)
    CALL zSetAnchorMode(hBut, %ANCHOR_NONE)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "This is an image button")

    hBut = zButImage(hMain, (SK_FOLDER() + "BTN_Play.png"), -100, -100, %ID_PLAYBUTTON, 0)
    CALL zGetImageSize(zGetButImageProperty(hBut), imgW, imgH): imgW = imgW \ 5
    CALL MoveWindow(hBut, (%XMIN_SIZE - imgW) \ 2, (%YMIN_SIZE \ 2) + ((%YMIN_SIZE \ 2) - imgH) \ 2, imgW, imgH, %TRUE)
    CALL zSetAnchorMode(hBut, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "This is an image button")

    hBut = zButImage(hMain, (SK_FOLDER() + "BTN_Left.png"), -100, -100, %ID_LEFTBUTTON, 0)
    CALL zGetImageSize(zGetButImageProperty(hBut), imgW, imgH): imgW = imgW \ 5
    CALL MoveWindow(hBut, (%XMIN_SIZE - imgW) \ 2 - 48 - 2, (%YMIN_SIZE \ 2) + ((%YMIN_SIZE \ 2) - imgH) \ 2, imgW, imgH, %TRUE)
    CALL zSetAnchorMode(hBut, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "This is an image button")

    hBut = zButImage(hMain, (SK_FOLDER() + "BTN_Right.png"), -100, -100, %ID_RIGHTBUTTON, 0)
    CALL zGetImageSize(zGetButImageProperty(hBut), imgW, imgH): imgW = imgW \ 5
    CALL MoveWindow(hBut, (%XMIN_SIZE - imgW) \ 2 + 50 + 2, (%YMIN_SIZE \ 2) + ((%YMIN_SIZE \ 2) - imgH) \ 2, imgW, imgH, %TRUE)
    CALL zSetAnchorMode(hBut, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "This is an image button")

    hBut = zFrameButton(hMain, (SK_FOLDER() + "Frame3D.png"), "", (%XMIN_SIZE - 200) \ 2, 265, 200, 67, %ID_FRAMEBUTTON, 0)
    CALL zSetAnchorMode(hBut, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zSetZorder(hBut, %HWND_TOP)

    CALL zSplitColorARGB(SK_AEROCOLOR(), Alpha, Red, Green, Blue)
    hBut = zTrackbar(hMain, (SK_FOLDER() + "BTN_Thumb.png"), 60, 350, 480, 20, %ID_TRACK_OPACITY, 0, 255, Alpha, SK_TRACKHICOLOR())
    CALL zSetAnchorMode(hBut, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "GLASS OPACITY level (AERO must be On)")

    hBut = zTrackbar(hMain, (SK_FOLDER() + "BTN_Thumb.png"), 30, 236, 20, 124, %ID_TRACK_BLURLEVEL, 20, 0, SK_AEROBLURLEVEL(), SK_TRACKHICOLOR())
    CALL zSetAnchorMode(hBut, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "GLASS BLUR level (AERO must be On)") ' // just want to show the value in the tooltip

    hBut = zCheckButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "AERO Crystal mode", 60, 264, 120, 22, %ID_AEROCRYSTAL, SK_BTNTEXTCOLOR(), 0)
    CALL zSetAnchorMode(hBut, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "Switch Skin display to CRYSTAL mode")

    hBut = zCheckButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "AERO Blur mode", 60, 286, 120, 22, %ID_AEROBLUR, SK_BTNTEXTCOLOR(), 0)
    CALL zSetAnchorMode(hBut, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "Switch Skin display to BLUR mode")

    hBut = zCheckButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "STANDARD mode", 60, 308, 120, 22, %ID_AERODISABLE, SK_BTNTEXTCOLOR(), 0)
    CALL zSetCheckButtonStatus(hBut, %TRUE)
    CALL zSetAnchorMode(hBut, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zSetZorder(hBut, %HWND_TOP)
    CALL zCreateToolTip(hBut, "Switch back to standard display mode")

'   // Change default LED's anchor mode from top right to top center
    CALL zSetAnchorMode(GetDlgItem(hMain, %ID_LED), %ANCHOR_CENTER_HORZ)
    CALL zSetZorder(GetDlgItem(hMain, %ID_LED), %HWND_TOP)

'   // Use the Skin's name for caption
    CALL zSetCTLText(hMain, (PARSE$(SK_AUTHOR(), $zLim, 1)))

'   // Setup PickColor control
    CALL zSplitColorARGB(SK_AEROCOLOR(), Alpha, Red, Green, Blue)
    hBut = zColorPick(SK_COLORLABEL(), 60, 236, 200, 21, hMain, %ID_COLORPICK, zRGBtoHEX(RGB(Red, Green, Blue)))
    CALL zSetAnchorMode(hBut, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zSetZorder(hBut, %HWND_TOP)

    hBut = zStaticLabel(hMain, "Color picker (static label)", 60, 220, 200, 13, %ID_LABEL, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT)
    CALL zSetAnchorMode(hBut, %ANCHOR_CENTER_HORZ_BOTTOM)

END SUB

'// Main window procedure
FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
    LOCAL ps AS PAINTSTRUCT
    LOCAL rc AS RECT
    LOCAL nRet, wP, hDC, hDCmem AS LONG
    LOCAL Alpha, Red, Green, Blue AS BYTE

    STATIC IsMoving AS LONG

    SELECT CASE LONG Msg
    CASE %WM_GETMINMAXINFO
         LOCAL pMM AS MINMAXINFO PTR
         pMM = lParam
         @pMM.ptMinTrackSize.x = zMinTrackSizeX(0)
         @pMM.ptMinTrackSize.y = zMinTrackSizeY(0)

    CASE %WM_COMMAND
         IF zButtonSysCommand(hWnd, wParam) THEN FUNCTION = 0: EXIT FUNCTION

         SELECT CASE LONG LOWRD(wParam)
         CASE %ID_AEROCRYSTAL
              IF zGetCheckButtonStatus(zGetMainItem(%ID_AEROCRYSTAL)) THEN
                 CALL zSplitColorARGB(SK_AEROCOLOR(), Alpha, Red, Green, Blue)
                 CALL zAEROCOLOR(zColorARGB(zGetTrackValue(zGetMainItem(%ID_TRACK_OPACITY)), RGB(Red, Green, Blue)), %WRITE)
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE), %FALSE)
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AEROBLUR), %FALSE)
                 CALL zAEROEMULATE(%TRUE, %WRITE)
                 CALL zAEROBLURLEVEL(0, %WRITE)
                 CALL zSetTrackValue(zGetMainItem(%ID_TRACK_BLURLEVEL), SK_AEROBLURLEVEL())
                 CALL SetTimer(hWnd, %AERO_TIMER, SK_AEROTIMERDELAY(), %NULL)

                 CALL zUSEVISTABLUR(%FALSE, %WRITE)
                 CALL zUSEVISTACRYSTAL(%TRUE, %WRITE)
                 
              ELSE
                 CALL KillTimer(hWnd, %AERO_TIMER)
                 CALL zAEROEMULATE(%FALSE, %WRITE)

                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE), %TRUE)

                 CALL zUSEVISTABLUR(%FALSE, %WRITE)
                 CALL zUSEVISTACRYSTAL(%FALSE, %WRITE)
              END IF
              CALL GetWindowRect(hWnd, rc)
              CALL zMoveBackground(rc.nLeft, rc.nTop)
              CALL zUpdateWindow(hWnd, 0)
         CASE %ID_AEROBLUR
              IF zGetCheckButtonStatus(zGetMainItem(%ID_AEROBLUR)) THEN
                 CALL zSplitColorARGB(SK_AEROCOLOR(), Alpha, Red, Green, Blue)
                 CALL zAEROCOLOR(zColorARGB(zGetTrackValue(zGetMainItem(%ID_TRACK_OPACITY)), RGB(Red, Green, Blue)), %WRITE)
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE), %FALSE)
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AEROCRYSTAL), %FALSE)
                 CALL zAEROEMULATE(%TRUE, %WRITE)
                 CALL zAEROBLURLEVEL(6, %WRITE)
                 CALL zSetTrackValue(zGetMainItem(%ID_TRACK_BLURLEVEL), SK_AEROBLURLEVEL())
                 CALL SetTimer(hWnd, %AERO_TIMER, SK_AEROTIMERDELAY(), %NULL)

                 CALL zUSEVISTACRYSTAL(%FALSE, %WRITE)
                 CALL zUSEVISTABLUR(%TRUE, %WRITE)

              ELSE
                 CALL KillTimer(hWnd, %AERO_TIMER)
                 CALL zAEROEMULATE(%FALSE, %WRITE)

                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE), %TRUE)

                 CALL zUSEVISTABLUR(%FALSE, %WRITE)
                 CALL zUSEVISTACRYSTAL(%FALSE, %WRITE)

              END IF
              CALL GetWindowRect(hWnd, rc)
              CALL zMoveBackground(rc.nLeft, rc.nTop)
              CALL zUpdateWindow(hWnd, 0)
         CASE %ID_AERODISABLE
              IF zGetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE)) THEN
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AEROBLUR), %FALSE)
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AEROCRYSTAL), %FALSE)
                 CALL zAEROEMULATE(%FALSE, %WRITE)
                 CALL KillTimer(hWnd, %AERO_TIMER)

                 CALL zUSEVISTABLUR(%FALSE, %WRITE)
                 CALL zUSEVISTACRYSTAL(%FALSE, %WRITE)

                 CALL GetWindowRect(hWnd, rc)
                 CALL zMoveBackground(rc.nLeft, rc.nTop)
                 CALL zUpdateWindow(hWnd, 0)
              ELSE
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AERODISABLE), %TRUE)
              END IF
         CASE %ID_TRACK_OPACITY
              IF SK_AEROEMULATE() THEN
                 CALL zSplitColorARGB(SK_AEROCOLOR(), Alpha, Red, Green, Blue)
                 CALL zAEROCOLOR(zColorARGB(lParam, RGB(Red, Green, Blue)), %WRITE)
                 CALL GetWindowRect(hWnd, rc)
                 CALL zMoveBackground(rc.nLeft, rc.nTop)
                 CALL zUpdateWindow(hWnd, 0)
              END IF

         CASE %ID_COLORPICK
              CALL zSplitColorARGB(lParam, A?, R?, G?, B?)
              CALL zAEROCOLOR(zColorARGB(zGetTrackValue(zGetMainItem(%ID_TRACK_OPACITY)), RGB(R?,G?,B?)), %WRITE)
              IF SK_AEROEMULATE() THEN
                 CALL GetWindowRect(hWnd, rc)
                 CALL zMoveBackground(rc.nLeft, rc.nTop)
                 CALL zUpdateWindow(hWnd, 0)
              END IF
         CASE %ID_TRACK_BLURLEVEL
              IF lParam <> SK_AEROBLURLEVEL() THEN
                 CALL zAEROBLURLEVEL(lParam, %WRITE)
                 IF SK_AEROEMULATE() THEN
                    CALL GetWindowRect(hWnd, rc)
                    CALL zMoveBackground(rc.nLeft, rc.nTop)
                    CALL zUpdateWindow(hWnd, 0)
                 END IF
              END IF
         END SELECT

    CASE %WM_SIZE
lRes& = zBeginDeferWindowPos(hWnd)
'         CALL zDrawBackground()
         CALL EnumChildWindows(hWnd, CODEPTR(AnchorEnum), lRes&)
         CALL zDrawBackground()
CALL zEndDeferWindowPos(hWnd, lRes&)      
 
    CASE %WM_SETTEXT
'        // Windows please do your job first.
         FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
'        // Update caption
         CALL zPaintBackground()
'        // Repaint only the caption.
         CALL GetClientRect(hWnd, rc)
         CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
         CALL InvalidateRect(hWnd, rc, 0)
         CALL UpdateWindow(hWnd)
         EXIT FUNCTION

    CASE %WM_NCLBUTTONDBLCLK
         IF IsIconic(hWnd) = 0 THEN
            LOCAL CaptionHeight AS LONG, p AS POINTAPI
            p.X = LOWRD(lParam): p.Y = HIWRD(lParam)
            CALL ScreenToClient(hWnd, p)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, CaptionHeight)
            IF p.Y < CaptionHeight THEN
               IF IsZoomed(hWnd) THEN
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_RESTORE, 0))
               ELSE
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_MAXIMIZE, 0))
               END IF
               FUNCTION = 0: EXIT FUNCTION
            END IF
         END IF

    CASE %WM_NCACTIVATE
         LOCAL hBut AS LONG
         hBut = GetDlgItem(hWnd, %ID_LED)
         IF hBut THEN
'           // Windows please do your job first.
            FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
            IF zMainWindow(0) = GetForegroundWindow THEN
               gColorCaption = SK_ACTIVECAPTION()
            ELSE
               gColorCaption = SK_INACTIVECAPTION()
            END IF
'           // Update caption
            CALL zPaintBackground()

'           // Repaint only the caption.
            CALL GetClientRect(hWnd, rc)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
            CALL InvalidateRect(hWnd, rc, 0)
            CALL UpdateWindow(hWnd)

            EXIT FUNCTION
         END IF

    CASE %WM_ERASEBKGND
        'CALL zPaintToScreen(hWnd, wParam, 0, 0, 0)
         FUNCTION = 1: EXIT FUNCTION

    CASE %WM_PAINT
         BeginPaint(hWnd, ps)
         CALL zPaintToScreen(hWnd, ps.hDC, 0, 0, 0)
         CALL EndPaint(hWnd, ps)
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_DESTROY
'        // Delete the GDIPLUS image skin components
         LOCAL K AS LONG
         FOR K = %FORM_TopLeft TO %FORM_BottomRight
             CALL zDisposeImage(zGetProperty(hWnd, K))
         NEXT
'        // Clear paint resources
         LOCAL hPaintBitmap AS LONG
         hPaintBitmap = zGetPaintBitmap(hWnd)
         CALL zDeleteObject(hPaintBitmap): CALL zSetProperty(hWnd, %FORM_PaintBitmap, hPaintBitmap)
         hDC = zGetPaintDC(hWnd)
         IF hDC THEN CALL DeleteDC(hDC): hDC = 0: CALL zSetProperty(hWnd, %FORM_PaintDC, hDC)

         CALL PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION

'        //START AERO section ---------------------------------------------------------
         CASE %WM_TIMER
              IF zDwmIsCompositionEnabled() = 0 THEN

              IF SK_AEROEMULATE() AND zIsAeroLayered() THEN
                 IF zIsLButtonDown() = 0 THEN IsMoving = 0
                 IF IsMoving = 0 OR (zIsLButtonDown() AND IsMoving) THEN
                    CALL GetWindowRect(hWnd, rc)
                    CALL zMoveBackground(rc.nLeft, rc.nTop)
                    CALL zUpdateWindow(hWnd, 0)
                 END IF
              END IF

              END IF

         CASE %WM_NCLBUTTONDOWN
              IsMoving = -1

         CASE %WM_MOVING
              IF zDwmIsCompositionEnabled() = 0 THEN

              IF SK_AEROEMULATE() AND zIsAeroLayered() THEN
                 DIM rw AS RECT PTR
                 rw = lparam
                 CALL zUpdateWindow(hWnd,0)
                 CALL zMoveBackground(@rw.nLeft,@rw.nTop)
                 CALL zUpdateWindow(hWnd,0)
                 FUNCTION = 1: EXIT FUNCTION
              END IF

              END IF
'        //END AERO section ---------------------------------------------------------

    END SELECT

    FUNCTION = zDefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION
